Highcharts.setOptions({
	global: {
		useUTC: false
	}
});

// definitions
var COLOR_WARNING_HIGH_LINE = '#E06363';
var COLOR_WARNING_LOW_LINE = '#59B4E2';
var FONT_SIZE_PLOTLINE_LABEL = '12px';
var OFFSET_X_PLOTLINE_LABEL = 0;
var OFFSET_Y_PLOTLINE_LABEL = -2;
var OFFSET_Y_PLOTLINE_LABEL_LOW=12;

var COLOR_FILL_AREA_SPLINE_L = '#4b74a1';
var COLOR_FILL_AREA_SPLINE_M = '#2f6b75';
var COLOR_FILL_AREA_SPLINE_H = '#d66868';
//var COLOR_FILL_AREA_SPLINE_NIGHT = '#97ffd2';
var COLOR_LABLE_L = 'rgba(75, 116, 161, 204)';
var COLOR_LABLE_M = 'rgba(47, 107, 117, 204)';
var COLOR_LABLE_H = 'rgba(214, 104, 104, 204)';
//
var COLOR_PLOTLINE_L = 'rgba(75, 116, 161, 128)';
var COLOR_PLOTLINE_M = 'rgba(47, 107, 117, 128)';
var COLOR_PLOTLINE_H = 'rgba(214, 104, 104, 128)';
//
var COLOR_BACKGROUND_L = '#e2e7ef';
var COLOR_BACKGROUND_M = '#c2e5e5'; 
var COLOR_BACKGROUND_H = '#f3e5e5';
var COLOR_BACKGROUND_N = '#222631';

var FONT_SIZE_EVENT_AXIS_LABEL = '10px';
var OFFSET_X_EVENT_AXIS_LABEL = -5;
var OFFSET_Y_EVENT_AXIS_LABEL = 3;

var XAXIS_LABLE_MARGIN_TOP = 12;
var XAXIS_TICKER_LENGTH = 1;
var YLABLE_MARGIN_LEFT = 7;
var YAXIS_SPACING_LEFT = 0;

// variables
var chart, event_chart, chart_bg;
var isUnitF = false;
var warnignHigh = 38.5;
var warningLow = 34.5;

var timeout_event_tooltip = 0;
var timeout_tooltip = 0;
var event_tooltip_x = 0;
var tooltip_x = 0;

// color variables
var chartColor = COLOR_FILL_AREA_SPLINE_M; //line color
var lableColor = COLOR_LABLE_M; //color for ticker and lable of x&y axis
var plotlineColor = COLOR_PLOTLINE_M; //for plotline
var chartBGColor = COLOR_BACKGROUND_M; //for tooltip background

// margin
var xAxis_label_margintop = 42; //margin top of lable of xAxis
var xAxis_tickLength = 3;
var yLable_margin_left = 7;
var chart_margin_left = YAXIS_SPACING_LEFT;
var event_margin_left = chart_margin_left + yLable_margin_left + 9*4 - 4;

// night or day mode
var dayMode = true;
//set an array as series data.
function setData(data_arrays){
var series0 = chart.series[0];
    series0.update({
                        data: data_arrays,
                    });
    chart.redraw();
}

// add temperature
function addTemperature(t0, t1, time, isShift)
{
  var series0 = chart.series[0];
  var series1 = chart.series[1];
  //var x = (new Date()).getTime() - time;
  var x = time;
  if (t0 <= -50.0)
  {
      series0.addPoint([x, null], false, isShift);
  }
  else
  {
      series0.addPoint([x, t0], false, isShift);
  }
  if (t1 <= -50.0)
  {
      series1.addPoint([x, null], false, isShift);
  }
  else
  {
      series1.addPoint([x, t1], false, isShift);
  }
}

// add temperature
function addTemperature_(t0,time)
{
  var series0 = chart.series[0];
  var x = time;
  if (t0 <= -50.0)
  {
      series0.addPoint([x, null], false);
  }
  else
  {
      series0.addPoint([x, t0], false);
  }
}

function addEvent(e, time, isShift)
{
    var series1 = event_chart.series[0];
    //var series2 = event_chart.series[1];
    //var x = (new Date()).getTime() - time;
    var x = time;
    var y;
    if (e == 1)
    {
        // physical cooling
        y = -0.01;
        event_chart.series[0].addPoint([x,y], false, isShift);
    }
    else if (e == 2)
    {
        // medicine
        y = 0.02;
        event_chart.series[1].addPoint([x,y], false, isShift);
    }
    //series1.addPoint([x,y], false, isShift);
}

function closeDataGrouping(){
    var series0=chart.series[0];
    series0.update({
        dataGrouping: {
                      enabled: false,
                    }
    });
}

function clearSeries(){
//怀疑效率太低下
//    var series0 = chart.series[0];
//    var data=series0.data;
//    while(data.length>0){
//        series0.removePoint(0,false,false);
//        data=series0.data;
//    }
        chart.series[0].update({
            data: [],
        });
        chart.series[1].update({
                    data: [],
                });
    chart.redraw();
}

//
function clearTooltip(){
    chart.pointer.reset();
    tooltip_x = 0;
}
function showSeries(showSeries0, showSeries1)
{
    var series0 = chart.series[0];
    var series1 = chart.series[1];

    if (showSeries0)
    {
        series0.show();
    }
    else
    {
        series0.hide();
    }

    if (showSeries1)
    {
        series1.show();
    }
    else
    {
        series1.hide();
    }
}

function showGrid(isShow){
    var xAxis=chart.series[0].xAxis;
    var yAxis=chart.series[0].yAxis;
    if(isShow){
        xAxis.update({
            gridLineWidth:1,
            gridLineColor:'#cccccc'
        });
        yAxis.update({
            gridLineWidth:1,
            gridLineColor:'#cccccc'
        });

    }else{
        xAxis.update({
            gridLineWidth:0
        });
        yAxis.update({
                    gridLineWidth:0,
                });
    }
}

function enableChartZoom(){
        if(chart){
        //chart.update 方法无法调用.
            /*chart.update({
                    chart:{
                        zoomType:'x'
                    }
                });*/
        }

    if(event_chart){
        /*event_chart.update({
                    chart:{
                        zoomType:'x'
                    }
                });*/
    }
}

function updateTemperatureWarningHighLine(newValue)
{
  var series = chart.series[0];
  var yAxis = series.yAxis;
  warnignHigh = newValue;
  yAxis.removePlotLine('warning-high');
  yAxis.addPlotLine({
      value: newValue,
      color: plotlineColor,
      dashStyle: 'ShortDash',
      width: 1,
      label: {
        align: 'right',
        text: getDisplayText(newValue),
        style: {
          color: plotlineColor,
          fontSize: FONT_SIZE_PLOTLINE_LABEL,
        },
        x: OFFSET_X_PLOTLINE_LABEL,
        y: OFFSET_Y_PLOTLINE_LABEL,
      },
      zIndex: 3,
      id: 'warning-high'
    });
}

function clearXAxisMarginTop(){
    chart.xAxis[0].update({
        labels:{
            y:20,
        }
    });
}

function updateTemperatureWarningLowLine(newValue)
{
  var series = chart.series[0];
  var yAxis = series.yAxis;
  warningLow = newValue;
  yAxis.removePlotLine('warning-low');
  yAxis.addPlotLine({
      value: newValue,
      color: plotlineColor,
      dashStyle: 'ShortDash',
      width: 1,
      label: {
        align: 'right',
        text: getDisplayText(newValue),
        style: {
          color: plotlineColor,
          fontSize:  FONT_SIZE_PLOTLINE_LABEL
        },
        x: OFFSET_X_PLOTLINE_LABEL,
        y: OFFSET_Y_PLOTLINE_LABEL_LOW,
      },
      zIndex: 3,
      id: 'warning-low'
    });
}

function updateXRange(range)
{
  var series = chart.series[0];
  var series_event = event_chart.series[0];
  var xAxis = series.xAxis;
  var xAxis_event = series_event.xAxis;
  var now = (new Date()).getTime();
  xAxis.setExtremes(now-range, now, false);
  xAxis_event.setExtremes(now-range, now, false);
}

function updateXExtremes(x0, x1)
{
    var series = chart.series[0];
    var series_event = event_chart.series[0];
    var xAxis = series.xAxis;
    var xAxis_event = series_event.xAxis;
    var now = (new Date()).getTime();
    xAxis.setExtremes(now-x0, now-x1, false);
    xAxis_event.setExtremes(now-x0, now-x1, false);
}

function updateYUnit(isF)
{
    isUnitF = isF;
    updateTemperatureWarningHighLine(warnignHigh);
    updateTemperatureWarningLowLine(warningLow);
    chart.redraw();
}

function redraw()
{
  event_chart.redraw();
  chart.redraw();
}

function getDisplayText(value)
{
    var result = value;
    if (isUnitF)
    {
        result = result * 9.0 / 5.0 + 32;
    }
    return result.toFixed(1) + "°";
}

function updateDisplayMode(isNightMode)
{
	dayMode = !isNightMode;
    /*if (chartColor== COLOR_FILL_AREA_SPLINE_L){
		level = 0;
	}else if (chartColor==COLOR_FILL_AREA_SPLINE_M){
		level = 1;
	}else if (chartColor==COLOR_FILL_AREA_SPLINE_H){
		level = 2;
	}
	updateTempColor(level);
    
	chart.redraw();*/
}

function updateTempColor(level)
{
	var icon_cold, icon_medicine;
    if (level==0){
        chartColor = COLOR_FILL_AREA_SPLINE_L;
		lableColor = COLOR_LABLE_L;
		plotlineColor = COLOR_PLOTLINE_L;
		if (dayMode){
			chartBGColor = COLOR_BACKGROUND_L;
		}
		icon_cold = 'url(./img/icon_curve_cold_low.png)';
		icon_medicine = 'url(./img/icon_curve_medicine_low.png)';
    }else if (level==1){
		chartColor = COLOR_FILL_AREA_SPLINE_M;
		lableColor = COLOR_LABLE_M;
		plotlineColor = COLOR_PLOTLINE_M;
		if (dayMode){
			chartBGColor = COLOR_BACKGROUND_M;
		}
		icon_cold = 'url(./img/icon_curve_cold.png)';
		icon_medicine = 'url(./img/icon_curve_medicine.png)';
	}else if (level==2){
        chartColor = COLOR_FILL_AREA_SPLINE_H;
		lableColor = COLOR_LABLE_H;
		plotlineColor = COLOR_PLOTLINE_H;
		if (dayMode){
			chartBGColor = COLOR_BACKGROUND_H;
		}
		icon_cold = 'url(./img/icon_curve_cold_high.png)';
		icon_medicine = 'url(./img/icon_curve_medicine_high.png)';
    }
	if (!dayMode){
		chartBGColor = COLOR_BACKGROUND_N; //night mode
	}
    chart.series[0].update({
              color: chartColor
          });
	chart.series[1].update({
              color: chartColor
          }); 
    chart.xAxis[0].update({
                lineColor: lableColor,
                tickColor: lableColor,
                labels: {
                        style: {
                            color: lableColor,
                        }
                },
				crosshair: {
					color: lableColor,
				}
            });
    chart.yAxis[0].update({
                labels: {
                        style: {
                            color: lableColor,
                        }
                },
            });

    //document.body.style.backgroundColor = chartBGColor;
	
	updateTemperatureWarningHighLine(warnignHigh);
	updateTemperatureWarningLowLine(warningLow);
	
    /*event_chart.series[0].update({
              color: chartColor
          });*/
	event_chart.series[0].update({
		marker:{
			symbol: icon_cold,
			height: 16,
            width: 16,
		},
	});
	event_chart.series[1].update({
		marker:{
			symbol: icon_medicine,
			height: 16,
            width: 16,
		},
	});

    //alert("level="+level);
}

function showZone(showZone){
	if (showZone){
		chart.series[0].update({
			zones: [{
					   value: warningLow,
					   color: COLOR_FILL_AREA_SPLINE_L
					 }, {
					   value: warnignHigh,
					   color: COLOR_FILL_AREA_SPLINE_M
					 }, {
					   color: COLOR_FILL_AREA_SPLINE_H
					 } ]
		});
		chart.series[1].update({
			zones: [{
					   value: warningLow,
					   color: COLOR_FILL_AREA_SPLINE_L
					 }, {
					   value: warnignHigh,
					   color: COLOR_FILL_AREA_SPLINE_M
					 }, {
					   color: COLOR_FILL_AREA_SPLINE_H
					 } ]
		});
	}else{
		chart.series[0].update({
			zones: []
		});
		chart.series[1].update({
			zones: []
		});
	}
}

//set margin according to density of the phone
function setMargin(density){
    //xAxis_label_margintop = XAXIS_LABLE_MARGIN_TOP * density;
    xAxis_tickLength = XAXIS_TICKER_LENGTH * density;
    yLable_margin_left = YLABLE_MARGIN_LEFT * density;
}


// for testing
function randomTempture() {
    var time = (new Date()).getTime();
	var t0 = t1 = Math.abs(Math.random()) * 5 + 35;
	addTemperature(t0, t1, time, false);
	updateXRange(60*2*1000);
	redraw();
}

function addEventTest(event){
	var time = (new Date()).getTime();
	addEvent(event, time, false);
	updateXRange(60*2*1000);
	redraw();
}


$(function() {
  document.documentElement.style.webkitTouchCallout = "none"; //禁止弹出菜单
  document.documentElement.style.webkitUserSelect = "none";//禁止选中
  document.body.style.backgroundColor = "transparent";


  chart_spline = document.getElementById("chart_spline");

  if (chart_spline)
  {
    chart_id = 'chart_spline';
    chart_type = 'spline';
    chart_h = $("#chart_spline").height();
    chart_w = $("#chart_spline").width();
    Y_MIN = null;
  }


  chart = new Highcharts.Chart({
    chart: {
      // container DIV
      renderTo: chart_id,
      // spline
      type: chart_type,
      backgroundColor: 'transparent',
      // disable zoom in area
      panning: false,
      //marginLeft: chart_margin_left, //fix area from left to the plot area, for syncing event
      spacingLeft: chart_margin_left,
      animation:false,
      zoomType:'x',
      resetZoomButton:{
        theme:{
            display:'none'
        }
      }
    },

    title: {
      text: "",
    },

    xAxis: { // setup x axis
      type: 'datetime',
      labels: {
        enabled: true,
        y: xAxis_label_margintop,
        style: {
            color: lableColor,
            fontSize: '9px',
        }
      },
      tickLength: xAxis_tickLength,
      tickPosition: 'inside',
      tickColor:lableColor,
      lineColor:lableColor,
	  crosshair: {
            width: 1,
            color: lableColor,
            dashStyle: 'Dash'
      },
    },

    yAxis: {// setup y axis
      title: {
        text: '',
        offset: 0,
        margin: 0
      },

      startOnTick: false,
      endOnTick: false,

      gridLineWidth: 0,
      lineWidth: 0,
      tickInterval: 0.5,
      tickAmount: 6,
      minRange: 1.0,

      offset: -YLABLE_MARGIN_LEFT,
      floor: Y_MIN,

      labels : {
        enabled : true,
        style: {
          color: lableColor,
          fontSize: '9px',
        },
        formatter: function(){
          var result = this.value;
          if (isUnitF)
          {
            result = result * 9.0 / 5.0 + 32;
          }
          return result.toFixed(1);
        },
        //x: -yLable_margin_left,
        y: 5
      },

      // warning lines
      plotLines: [{
        value: warnignHigh,
        color: plotlineColor,
        dashStyle: 'ShortDash',
        width: 1,
        label: {
          align: 'right',
          text: getDisplayText(warnignHigh),
		  style: {
			color: plotlineColor,
			fontSize: FONT_SIZE_PLOTLINE_LABEL
		  },
          x: OFFSET_X_PLOTLINE_LABEL,
          y: OFFSET_Y_PLOTLINE_LABEL,
         },
        id: 'warning-high',
        },
        {
        value: warningLow,
        color: plotlineColor,
        dashStyle: 'ShortDash',
        width: 1,
        label: {
          align: 'right',
          text: getDisplayText(warningLow),
		  style: {
			color: plotlineColor,
			fontSize: FONT_SIZE_PLOTLINE_LABEL
		  },
          x: OFFSET_X_PLOTLINE_LABEL,
          y: OFFSET_Y_PLOTLINE_LABEL_LOW,
         },
        id: 'warning-low',
      }]
    },

    plotOptions: {
      spline: {
        lineWidth: 2,
        color: chartColor,
        marker: {
            enabled: false
        },
      },
      series:
      {
        connectNulls: false,
        dataGrouping: {
          enabled: true,
          approximation: 'high',
        },
        /*events: {
            click: function () {
                //chart.redraw();
                setInterval( "chart.redraw()", 100 );
            }
        },*/
      },
    },

    tooltip: { // tooltip
      //followPointer: true,
      followTouchMove: true,
      shared: false,
      useHTML:true,
      /*crosshair: {
                  width: 1,
                  color: lableColor,
                  dashStyle: 'Dash'
            },*/

      formatter: function(lw, lh, p) { // format

        var value = this.y;
        var unit = '℃';
        var html;
        if (tooltip_x != this.x)
        {
            clearTimeout(timeout_tooltip);
            timeout_tooltip = setTimeout (function () {
                                          chart.pointer.reset();
                                          tooltip_x = 0;
                                      }, 3000);
            tooltip_x = this.x;
        }
        if (isUnitF)
        {
            value = value * 9 / 5 + 32;
            unit = '℉';
        }

		if (!dayMode){
		    html = "<div style=\"text-align:center;background-color:#222631;"
		    if (chartColor==COLOR_FILL_AREA_SPLINE_L){
		        html +="color:#4b74a1;\">"
		    }else if (chartColor==COLOR_FILL_AREA_SPLINE_M){
				html +="color:#2f6b75;\">"
			}else{
				html +="color:#d66868;\">"
			}
		}else{
			if (chartColor==COLOR_FILL_AREA_SPLINE_L){
				html = "<div style=\"text-align:center; color:#4b74a1;background-color:#e2e7ef;\">"
			}else if (chartColor==COLOR_FILL_AREA_SPLINE_M){
				html = "<div style=\"text-align:center; color:#2f6b75;background-color:#c2e5e5;\">"
			}else{
				html = "<div style=\"text-align:center; color:#d66868;background-color:#f3e5e5;\">"
			}
		}

        html += '<span style=\"font-size:16px; \">' + Highcharts.numberFormat(value, 2) + '</span><span style=\"font-size:8px;vertical-align:top;\">'
			+ unit + '</span><br/><span style=\"font-size:8px;margin-right:20px;margin-left:20px\">' + Highcharts.dateFormat('%H:%M:%S', this.x)  + "</span></div>";
		return html;
      },
      borderWidth: 0,
	  backgroundColor: 'transparent',
      //snap: 100,
      shadow: false,
      hideDelay: 0,
    },

    legend: {
      enabled: false
      // no legend
    },

    exporting: {
      enabled: false
      // no export
    },

    credits: {
      enabled: false
    },

    series: [{
               data: [],
             },
             {
               data: []
             }
    ]
  });


  event_chart = new Highcharts.Chart({
      chart: {
        // container DIV
        renderTo: 'chart_event',
        // spline
        type: 'scatter',
        backgroundColor:'transparent',
        panning: false,
        //marginLeft: chart_margin_left, //fix area from left to the plot area, for syncing event
        spacingLeft: event_margin_left,
        resetZoomButton:{
                theme:{
                    display:'none'
                }
              }
      },

      //colors:[chartColor],

      title: {
        text: "",
      },

      legend: {
        enabled: false
      },

      exporting: {
        enabled: false
      },

      credits: {
        enabled: false
      },

      xAxis: { // setup x axis
        type: 'datetime',
        labels: {
          enabled: false,
        },
        tickLength: 0,
        lineWidth:0,
      },

      yAxis: {// setup y axis
        title: {
          text: ""
        },
        min:-5,
        max:0.1,
        gridLineWidth: 0,
        opposite : false,
        labels : {
          enabled : false,
        },
      },

      tooltip: { // tooltip
        followTouchMove: false,
        useHTML: true,
        crosshairs: false,
        formatter: function() { // format
          var value = this.y;
          var image;
          if (event_tooltip_x != this.x)
          {
              clearTimeout(timeout_event_tooltip);
              timeout_event_tooltip = setTimeout (function () {
                                                      event_chart.pointer.reset();
                                                      event_tooltip_x = 0;
                                                  }, 8000);
              event_tooltip_x = this.x;
          }
          /*if (value == 0.01)
          {
            image = "<img src=\"img/cooling.png\" width=15 height=15 style=\"vertical-align:middle;\"/>";
          }
          else if (value == 0.02)
          {
            image = "<img src=\"img/medicine.png\" width=15 height=15 style=\"vertical-align:middle;\"/>";
          }*/

          if (chartColor==COLOR_FILL_AREA_SPLINE_L){
                html = "<div style=\"text-align:center; color:#4b74a1; font-size:9px\">"
            }else if (chartColor==COLOR_FILL_AREA_SPLINE_M){
                html = "<div style=\"text-align:center; color:#2f6b75; font-size:9px\">"
            }else{
                html = "<div style=\"text-align:center; color:#d66868; font-size:9px\">"
            }
            html += Highcharts.dateFormat('%H:%M', this.x) + "</div>";
          return  html;
        },
        style:{
          color: chartColor,
          fontSize: '13px',
        },
        borderWidth: 0,
        backgroundColor: 'transparent',
        positioner: function (lw,lh,p) {
          return { x: p.plotX+16, y: p.plotY+12};

        },
        snap: 100,
        shadow: false,
        hideDelay: 0,
      },

      series:[
		{
            data:[],
            marker: {
              symbol: 'url(./img/icon_curve_cold.png)',
              height: 16,
              width: 16,
              states: {
                hover: {
                    enabled: false
                    }
              }
            }
        },
		{
            data:[],
            marker: {
              symbol: 'url(./img/icon_curve_medicine.png)',
              height: 16,
              width: 16,
              states: {
                hover: {
                    enabled: false
                    }
              }
            }
        },

      ]
    });

});

